--当季热卖
Lua_QuarterHotSellPanel = class("Lua_QuarterHotSellPanel", Lua_DisplayObject);
function Lua_QuarterHotSellPanel:ctor(p)
	self:superCall("ctor", p, "QuarterHotSellPanel_skin");
end

function Lua_QuarterHotSellPanel:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:stopTimer();

	self:superCall("dispose");
end

function Lua_QuarterHotSellPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content, 660, 820 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_QuarterHotSellItem, 216, 304, 3);
	self.dragList:setCellSpacing(6, 10);
	self.dragList:setLocation(0, -57);
	self.dragList.tweenId = 2003;
    
    self.infoBg.pivotValue = 1;
	self.infoBg:setLocation(0, -347);
	self.infoBg:SetDimensions(695, 1006 + self.adaptHeight);

	self:addLuaEvent("UPDATE_QUARTERHOTSELL_PANEL", self, self.updatePanel);
	self:addLuaEvent("QUARTERHOTSELL_BUY", self, self.buyCommodity);
end

function Lua_QuarterHotSellPanel:updatePanel(msg)
	if msg == nil then
		return;
	end

	table.sort(msg.seller_list ,
	 function(a, b)
		if a.num > 0 and b.num > 0 then
			return a.id < b.id;
		elseif a.num <= 0 and b.num <= 0 then
			return a.id < b.id;
		else
			return a.num > b.num;
		end
	end
	);
	self.dragList:setArrayData(msg.seller_list);
end

function Lua_QuarterHotSellPanel:setData(actVo)
	self.actVo = actVo;

	if actVo.residueTime > 0 then
		local timeStr = Lua_TimeTransform.transSeconds16(actVo.residueTime, true, true, true);
		self.timeTxt.text = LanUtil.formateStr(630000, timeStr);
		self:startTimer();
	else
		self:stopTimer();
	end
end

function Lua_QuarterHotSellPanel:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:addTimer("QuarterHotSellDownTimer", 1, self, self.updateTime);
	end
end

function Lua_QuarterHotSellPanel:stopTimer()
	if self.bTimer == true then
		self.bTimer = false;
		Lua_CommonUtil.removeTimer(self, self.updateTime);
	end
end

function Lua_QuarterHotSellPanel:updateTime()
	if self.actVo.residueTime > 0 then
		local timeStr = Lua_TimeTransform.transSeconds16(self.actVo.residueTime, true, true, true);
		self.timeTxt.text = LanUtil.formateStr(630000, timeStr);
	else
		self.timeTxt.text = nil;
		self:stopTimer();
	end
end

function Lua_QuarterHotSellPanel:buyCommodity(id)
	if id == nil or self.actVo.actIdx == nil then
		return;
	end
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sBuyQuarterGift(self.actVo.actIdx, id);
end

function Lua_QuarterHotSellPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
	self.dragList:setContentRect(660, 820 + adaptHeight);
	self.infoBg:SetDimensions(695, 1006 + adaptHeight);
end









Lua_QuarterHotSellItem = class("Lua_QuarterHotSellItem", Lua_ListCell)
function Lua_QuarterHotSellItem:ctor(p)
	self:superCall("ctor", p, "QuarterHotSellItem_skin");
end

function Lua_QuarterHotSellItem:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	if self.pressItem ~= nil then
		self.pressItem:dispose();
		self.pressItem = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end

function Lua_QuarterHotSellItem:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content, 200, 62, Lua_AxisDefine.Horizontal);
	self.dragList:setLocation(0, -25);
	self:setSubList(self.dragList);
end

function Lua_QuarterHotSellItem:setData(data)
	if data == nil then
		return;
	end

	self.data = data;
    local arr = Array();
	if #data.item_list >= 4 then
		for i = 1, #data.item_list do
			arr:add({itemData = data.item_list[i], scale = 0.4, isGray = data.num <= 0});
		end
		self.dragList:setListCell(Lua_QuarterHotSellIconCell, 50, 50, 1);
		self.dragList:setContentRect(200, 50);
		self.dragList:setArrayData(arr);
	else
		for i = 1, #data.item_list do
			arr:add({itemData = data.item_list[i], scale = 0.5, isGray = data.num <= 0});
		end
		self.dragList:setListCell(Lua_QuarterHotSellIconCell, 62, 62, 1);
		self.dragList:setContentRect(62 * #data.item_list, 62);
		self.dragList:setArrayData(arr);
	end
	self.dragList.canDrag = #data.item_list > 4;

	self.timesTxt.text = LanUtil.formateStr(630002, data.num);
	if data.icon_config ~= nil then
		self.giftPackSp:setAltas(data.icon_config.icon_atlas, data.icon_config.icon_index);	
	end
	self.giftPackSp:resetSize();
	self.noneSp:setEnable(data.num <= 0);
	self.bg:setGray(data.num <= 0);
	self.costTxt:setGray(data.num <= 0);
	self.moneyIcon:setGray(data.num <= 0);
	self.giftPackSp:setGray(data.num <= 0);

	if data.type == 1 then
		if data.price == 0 then
			self.costTxt:setLangValue(630003);
			self.costTxt:setLocation(0, -117);
			self.moneyIcon:setEnable(false);
			if self.redPoint == nil then
				self.redPoint = Lua_RedPointIcon.new(self.content);
				self.redPoint:createRedPointEff();
				self.redPoint:setLocation(100, 140);
			end
		else
			self.costTxt.text = data.price;
			self.costTxt:setLocation(15, -117);
			self.moneyIcon:setEnable(true);
			self.moneyIcon:setLocation(-15 - (self.costTxt.width - 16) / 2, -116);
		end
		self.costTxt:resetSize();
	elseif data.type == 2 then
		if data.price == 0 then
			self.costTxt:setLangValue(630003);
			if self.redPoint == nil then
				self.redPoint = Lua_RedPointIcon.new(self.content);
				self.redPoint:createRedPointEff();
				self.redPoint:setLocation(100, 140);
			end
		else
			self.costTxt.text = LanUtil.formateStr(630001, data.price);
		end
		self.costTxt:setLocation(0, -117);
		self.moneyIcon:setEnable(false);
	end
	if self.redPoint ~= nil then
		self.redPoint:updateRedPointShow(data.price <= 0 and data.num > 0);
	end
end

function Lua_QuarterHotSellItem:onPressClick()
	if self.data == nil or self.data.id == nil or self.data.num <= 0 then
		return;
	end

	local winPos = LuaUtil.getTouchPosInverseObj(self.dragList.sub);
	for i = 1, self.dragList.showList:getSize() do
		if self.dragList.showList[i]:checkInBound(winPos.x, winPos.y) then
			return;
		end
	end

	if self.data.type == 1 then
		if DataCenter.moneyData:isMoneyEnough(Lua_ResourcesDefine.DIAMOND, tonumber(self.data.price), true, true) then
			Lua_MsgUtil.callFunc("QUARTERHOTSELL_BUY", self.data.id);
		end 
	elseif self.data.type == 2 then
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(self.data.id);
		if rechargeInfo ~= nil then
			DataCenter.sdkInterface:PointOut(tonumber(rechargeInfo.gold), tonumber(rechargeInfo.money),
			tonumber(rechargeInfo.money_type), tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
		end
	end
end

function Lua_QuarterHotSellItem:checkClick()
	local winPos = LuaUtil.getTouchPosInverseObj(self.dragList.sub);
	for i = 1, self.dragList.showList:getSize() do
		if self.dragList.showList[i]:checkInBound(winPos.x, winPos.y) then
			return self.dragList.showList[i];
		end
	end
	return nil;
end

function Lua_QuarterHotSellItem:onMouseDownHandle()
	if #self.data.item_list > 4 then
		return;
	end
	self.pressItem = self:checkClick();
	if self.pressItem ~= nil then
		self.pressItem:onMouseDownHandle();
	end
end

function Lua_QuarterHotSellItem:onMouseUpHandle()
	if #self.data.item_list > 4 then
		return;
	end
	if self.pressItem ~= nil then
		self.pressItem:onMouseUpHandle();
	end
end










Lua_QuarterHotSellIconCell = class("Lua_QuarterHotSellIconCell", Lua_ListCell)
function Lua_QuarterHotSellIconCell:ctor(p)
	self:superCall("ctor", p);
end

function Lua_QuarterHotSellIconCell:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	--self.itemIcon:setCanClick(true);
end

function Lua_QuarterHotSellIconCell:setData(data)
	self.data = data;

	if self.itemVo == nil then
		self.itemVo = Lua_ToolVo.createToolVo(data.itemData.id);
	else
		self.itemVo:setData(data.itemData.id);
	end
	self.itemVo:fromServer(data.itemData);
	self.itemIcon:setData(self.itemVo);
	self.itemIcon:setScale(data.scale, data.scale);
	self.itemIcon:setGray(data.isGray);
end

function Lua_QuarterHotSellIconCell:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self.data = nil;
	self.itemVo = nil;
end

function Lua_QuarterHotSellIconCell:onPressClick()
	if self.data.isGray then
		return;
	end
	self.itemIcon:onItemClick();
end

function Lua_QuarterHotSellIconCell:onMouseDownHandle()
	self.itemIcon:setScale(self.data.scale * 0.95, self.data.scale * 0.95);
end

function Lua_QuarterHotSellIconCell:onMouseUpHandle()
	self.itemIcon:setScale(self.data.scale, self.data.scale);
end