-- BOSS挑战 1每日挑战奖励 2下一阶段奖励
Lua_BossChallengeShowRewardWindow = class("Lua_BossChallengeShowRewardWindow", Lua_Window);
function Lua_BossChallengeShowRewardWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_BossChallengeShowRewardWindow";
	self.skinName = "BossChallengeShowRewardWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showCloseText = true;
	self.closeTextPosY = -261;
end

function Lua_BossChallengeShowRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemList = Lua_DragList.new(self.content, 510, 112, Lua_AxisDefine.Horizontal);
	self.itemList:setListCell(Lua_BossChallengeDailyChallengeItem, 116, 112, 1);
end

function Lua_BossChallengeShowRewardWindow:showWin(param)
	self:superCall("showWin", param);

	local showList;
	if param == 1 then
		self.titleName:setLangValue(640011);
		showList = DataCenter.bossChallengeData.daily_item_list;
	else
		local stageInfo = DataCenter.bossChallengeData.daily_hurt_reward;
		local nextStageIdx = DataCenter.bossChallengeData.nextStageIdx;
		local isFinish = stageInfo[#stageInfo].is_finish == 0;
		if isFinish then
			self.titleName:setLangValue(640012);
		else
			self.titleName:setLangValue(640021);
		end

		showList = stageInfo[nextStageIdx].item_list;
	end
	local len = #showList;
	local posX = len > 4 and 0 or (510 - len * 116) / 2;
	self.itemList.canDrag = len > 4;
	self.itemList:setArrayData(showList);
	self.itemList:setLocation(posX, -72, 0);
end

function Lua_BossChallengeShowRewardWindow:dispose()
	if self.itemList then
		self.itemList:dispose()
		self.itemList = nil
	end
	self:superCall("dispose")
end










Lua_BossChallengeDailyChallengeItem = class("Lua_BossChallengeDailyChallengeItem", Lua_ItemIconCell);
function Lua_BossChallengeDailyChallengeItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.8, 0.8);
end

function Lua_BossChallengeDailyChallengeItem:onPressClick()
	local checkItem = self:checkClick();
	if self.pressItem ~= nil and checkItem == self.pressItem then
		self.pressItem:onItemClick();
	end
end

function Lua_BossChallengeDailyChallengeItem:checkClick()
	local winPos = LuaUtil.getTouchPosInverseObj(self.mainContent);
	if self.itemIcon.isActive and self.itemIcon:checkInBound(winPos.x, winPos.y) then
		return self.itemIcon;
	end
	return nil;
end

function Lua_BossChallengeDailyChallengeItem:onMouseDownHandle()
	self.pressItem = self:checkClick();
	if self.pressItem ~= nil then
		self.pressItem:setScale(0.7, 0.7);
	end
end

function Lua_BossChallengeDailyChallengeItem:onMouseUpHandle()
	if self.pressItem ~= nil then
		self.pressItem:setScale(0.8, 0.8);
	end
end