-- 幸运礼盒详情界面信息
Lua_LuckyGiftBoxDetailWindow = class("Lua_LuckyGiftBoxDetailWindow", Lua_Window);
function Lua_LuckyGiftBoxDetailWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_LuckyGiftBoxDetailWindow";
	self.skinName = "LuckyGiftBoxDetailWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showClose = true;
end

function Lua_LuckyGiftBoxDetailWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.btnClose:setLocation(300, 455, 0);

	self.rewardDesList = Lua_DragList.new(self.content, 630, 270, Lua_AxisDefine.Vertical);
	self.rewardDesList:setListCell(Lua_RewardDesItem, 630, 35, 1);
	self.rewardDesList:setLocation(0, 153, 0);

	self.tipsDesContainer = Lua_DragContainer.new(self.content, 600, 330, Lua_AxisDefine.Vertical);
	self.tipsDesContainer:setLocation(0, -250, 0);
	self.tipsDesContainer:setCellPivot(1);

	self:addLuaEvent("UPDATE_LUCKYGIFTBOX_DETAIL_INFO", self, self.updateDetailInfo);
end

function Lua_LuckyGiftBoxDetailWindow:showWin(param)
	self:superCall("showWin", param);
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sLuckyGiftBoxDetailInfo(param);
end

function Lua_LuckyGiftBoxDetailWindow:updateDetailInfo()
	local detailInfoDic = DataCenter.luckyGiftBoxData.detailInfoDic;
	self.rewardDesList:setArrayData(detailInfoDic);
	self.rewardDesList.canDrag = #detailInfoDic * 35 > 270;

	local des = "这是规则说明这是规则说明这是规则说明这是规则说明";
	self.tipsDesContainer:addSubContainer(Lua_TipsDesItem, des, true);
	self.tipsDesContainer.canDrag = not self.tipsDesContainer.isTheEnd;
end

function Lua_LuckyGiftBoxDetailWindow:dispose()
	if self.rewardDesList ~= nil then
		self.rewardDesList:dispose();
		self.rewardDesList = nil;
	end
	if self.tipsDesContainer ~= nil then
		self.tipsDesContainer:dispose();
		self.tipsDesContainer = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_RewardDesItem = class("Lua_RewardDesItem", Lua_ListCell);
function Lua_RewardDesItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_RewardDesItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemDes = UICreate.createLabel(self.content, "", -155, 0, 250, 35, 26);
	self.itemDes.fontName = Lua_MyUISettings.huakangFontName;
	self.itemDes.alignmentValue = 3;

	self.countDes = UICreate.createLabel(self.content, "", 190, 0, 150, 35, 26);
	self.countDes.fontName = Lua_MyUISettings.huakangFontName;
	self.countDes.alignmentValue = 5;
end

function Lua_RewardDesItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.itemDes.text = LanUtil.formateStr("物品{1} x{2}", data.tvo.name, data.tvo.count);
	self.countDes.text = LanUtil.formateStr("{1}/{2}", data.residue_times, data.limit_times);
end

function Lua_RewardDesItem:dispose()
	if self.des ~= nil then
		self.des:dispose();
		self.des = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_TipsDesItem = class("Lua_TipsDesItem", Lua_ListCell);
function Lua_TipsDesItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_TipsDesItem:buildShowItem()
	self:superCall("buildShowItem");

	self.des = UICreate.createLabel(self.content, "", 0, 0, 600, 330, 26);
	self.des.verticalOverflowValue = 1;
	self.des.alignmentValue = 0;
end

function Lua_TipsDesItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.des.text = data;
end

function Lua_TipsDesItem:getWidth()
	return self.des.width;
end

function Lua_TipsDesItem:getHeight()
	return self.des.height;
end

function Lua_TipsDesItem:dispose()
	if self.des ~= nil then
		self.des:dispose();
		self.des = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end