--新英雄主题活动 试用英雄获得Window
Lua_NewHeroActShowWindow = class("Lua_NewHeroActShowWindow", Lua_Window);

function Lua_NewHeroActShowWindow:ctor()
    self:superCall("ctor");

    self.isFullSizeWin = true;
    self.showWinBg = true;
	self.winBgPath = "/images/common/ui_common_bg_001.jpg";

    self.windowName = "Lua_NewHeroActShowWindow";
    self.skinName = "NewHeroActShowWindow_skin";
end

function Lua_NewHeroActShowWindow:buildShowItem()
	self:superCall("buildShowItem");

	local heroVo = Lua_HeroVo.new(DataCenter.newHeroActData.trialHeroId);
	self.campIcon:setAltas("common_altas_2", "ui_common_button_0".. 25 + heroVo.campType .. "_n");
	self.nameTxt.text = heroVo.name;
	self.desTxt.text = heroVo.title;

	--更新星星显示
	local starIcon;
	self.starArr = Array();
	for i = 1, heroVo.star do
		starIcon = UICreate.createUIAtlasImage(self.content, "iconantlas1", "common_widget_024", 0, 0, 28, 28);
		starIcon:setLocation(i * 28 -100, 240);
		self.starArr:add(starIcon);
	end

	--更新展示模型显示
	if self.modeEffImg == nil then
		self.modeEffImg = UICreate.createModelEffImg(self.content, nil, nil, 0, -50, 300, 300);
		self.modeEffImg:setCamField(1, 1, 100, true);
		self.modeEffImg:setCamPos(0, 1, -10);
		self.modeEffImg:setModelEffDir(90);
		self.modeEffImg:setEnable(true);
		self.modeEffImg.canRot = true;
	end
	self.modeEffImg:setUrl(heroVo.modelUrl, heroVo.modelSrc)
	
	self.time = DataCenter.newHeroActData.trialTime * 24 * 3600 + 1;
	self:onTimer();
end

function Lua_NewHeroActShowWindow:dispose()
	self:removeTimer(self, self.onTimer);
	
	if self.starArr ~= nil then
		self.starArr:dispose();
		self.starArr = nil;
	end
	if self.modeEffImg ~= nil then
		self.modeEffImg:dispose();
		self.modeEffImg = nil;
	end
	self:superCall("dispose");
end

function Lua_NewHeroActShowWindow:onTimer()
	self.time = self.time - 1;
	if self.time < 0 then
		self.time = 0;
	end
	self.timeTxt.text = LanUtil.formateStr("体验时间：{1}", Lua_TimeTransform.transSeconds1(self.time));

	if self.time > 0 then
		if not self.isTimer then
			self.isTimer = true;
			self:addTimer("onTimer", 1, self, self.onTimer)
		end
	else
		if self.isTimer then
			self.isTimer = false;
			self:removeTimer(self, self.onTimer);
		end
	end
end

function Lua_NewHeroActShowWindow:onWinBgClick(go)
	self:hide();
end