-- 魔神试炼增益效果文本框
Lua_MonsterTrialPowerTipsWindow = class("Lua_MonsterTrialPowerTipsWindow", Lua_Window);
function Lua_MonsterTrialPowerTipsWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_MonsterTrialPowerTipsWindow";
	self.skinName = "MonsterTrialPowerTipsWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showClose = true;
end

function Lua_MonsterTrialPowerTipsWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.btnClose:setLocation(293, 330);

	self.allPowerContainer = Lua_DragContainer.new(self.content, 564, 180, Lua_AxisDefine.Vertical);
	self.allPowerContainer:setCellPivot(1);
	self.allPowerContainer:setLocation(0, 120, 0);

	self.powerContainer = Lua_DragContainer.new(self.content, 564, 180, Lua_AxisDefine.Vertical);
	self.powerContainer:setCellPivot(1);
	self.powerContainer:setLocation(0, -150, 0);

	self:updateDesInfo();
end

function Lua_MonsterTrialPowerTipsWindow:updateDesInfo()
	local newHeroActData = DataCenter.newHeroActData;
	self.levelTxt.text = LanUtil.formateStr("{1}", newHeroActData.buff_info.buff_name); -- Lv.{2}", newHeroActData.buff_info.buff_name, newHeroActData.buff_info.buff_lvl);

	local str = self:getDesInfo(newHeroActData.buff_info.hero_add, 1);
	local skillInfo = Lua_SkillConfigData.getConfigData(newHeroActData.buff_info.skill_info.key);
	str = str .. LanUtil.formateStr("技能【{1}】升至Lv.{2}，伤害系数{3}%", skillInfo.name, newHeroActData.buff_info.skill_info.value, Mathf.Floor(newHeroActData.buff_info.skill_info.other * 100));
	self.allPowerContainer:addSubContainer(Lua_DesItem, str, true, 0);
	str = self:getDesInfo(newHeroActData.buff_info.all_add, 2);
	self.allPowerContainer:addSubContainer(Lua_DesItem, str, true, 0);
	self.allPowerContainer.canDrag = not self.allPowerContainer.isTheEnd;

	str = self:getDesInfo(newHeroActData.buff_info.next_hero_add, 1);
	str = str .. LanUtil.formateStr("技能【{1}】升至Lv.{2}，伤害系数{3}%", skillInfo.name, newHeroActData.buff_info.next_skill_info.value, Mathf.Floor(newHeroActData.buff_info.next_skill_info.other * 100));
	self.powerContainer:addSubContainer(Lua_DesItem, str, true, 0);
	str = self:getDesInfo(newHeroActData.buff_info.next_all_add, 2);
	self.powerContainer:addSubContainer(Lua_DesItem, str, true, 0);
	self.powerContainer.canDrag = not self.powerContainer.isTheEnd;
end

function Lua_MonsterTrialPowerTipsWindow:getDesInfo(attribute, upType)
	local info;
	local desArr = Array();
	for k,v in ipairs(attribute) do
		vo = Lua_AttributesVo.new(v.name);
		info = {};
		info.show_name = vo.show_name;
		info.sort = vo.sort;
		info.power = v.value;
		desArr:add(info);
	end

	local str;
	if upType == 1 then
		local heroVo = Lua_HeroVo.new(DataCenter.newHeroActData.buff_info.hero_id);
		str = LanUtil.formateStr("{1}在试炼中", heroVo.name);
	else
		str = "所有英雄在试炼中";
	end

	desArr:sort("sort", false);
	for i = 1, desArr:getSize() do
		tab = {str, desArr[i].show_name, "+", desArr[i].power};
		str = table.concat(tab, "");
	end
	return str
end

function Lua_MonsterTrialPowerTipsWindow:dispose()
	if self.allPowerContainer ~= nil then
		self.allPowerContainer:dispose();
		self.allPowerContainer = nil;
	end
	if self.powerContainer ~= nil then
		self.powerContainer:dispose();
		self.powerContainer = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_DesItem = class("Lua_DesItem", Lua_ListCell);
function Lua_DesItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_DesItem:buildShowItem()
	self:superCall("buildShowItem");

	self.des = UICreate.createLabel(self.content, "", 0, 0, 564, 180, 30);
	self.des.fontName = Lua_MyUISettings.huakangFontName;
	self.des.colorStr = Lua_ColorDefine.transColorStr("669FFF");
	self.des.verticalOverflowValue = 1;
	self.des.alignmentValue = 0;
end

function Lua_DesItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.des.text = data;
end

function Lua_DesItem:getWidth()
	return self.des.width;
end

function Lua_DesItem:getHeight()
	return self.des.height + 5;
end

function Lua_DesItem:dispose()
	if self.des ~= nil then
		self.des:dispose();
		self.des = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end