-- 魔神试炼增益效果弹框
Lua_MonsterTrialPowerWindow = class("Lua_MonsterTrialPowerWindow", Lua_Window);
function Lua_MonsterTrialPowerWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_MonsterTrialPowerWindow";
	self.skinName = "MonsterTrialPowerWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showClose = true;
end

function Lua_MonsterTrialPowerWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.btnClose:setLocation(295, 455);

	self.allUpDesContainer = Lua_DragContainer.new(self.content, 495, 200, Lua_AxisDefine.Vertical);
	self.allUpDesContainer:setCellPivot(1);
	self.allUpDesContainer:setLocation(0, 90, 0);
	self.allUpDesContainer:setSiblingIndex(11);

	self.upDesContainer = Lua_DragContainer.new(self.content, 495, 200, Lua_AxisDefine.Vertical);
	self.upDesContainer:setCellPivot(1);
	self.upDesContainer:setLocation(0, -225, 0);
	self.upDesContainer:setSiblingIndex(11);
end

function Lua_MonsterTrialPowerWindow:showWin(param)
	self:superCall("showWin", param);

	self:updateDesInfo(param);
end

function Lua_MonsterTrialPowerWindow:updateDesInfo(buffInfo)
	self.preLvTxt.text = buffInfo.buff_lvl;
	self.curLvTxt.text = buffInfo.buff_lvl + 1;
	local skillInfo = Lua_SkillConfigData.getConfigData(buffInfo.skill_info.key);
	self.powerDesTxt.text = LanUtil.formateStr("技能【{1}】Lv.{2}", skillInfo.name, buffInfo.next_buff_lvl);

	local desArr = self:getAttributeInfo(buffInfo.all_add, buffInfo.next_all_add);
	for i = 1, desArr:getSize() do
		self.allUpDesContainer:addSubContainer(Lua_DesItem, desArr[i], true, 0);
	end
	self.allUpDesContainer.canDrag = not self.allUpDesContainer.isTheEnd;

	desArr = self:getAttributeInfo(buffInfo.hero_add, buffInfo.next_hero_add);
	for i = 1, desArr:getSize() do
		self.upDesContainer:addSubContainer(Lua_DesItem, desArr[i], true, 0);
	end
	self.upDesContainer.canDrag = not self.upDesContainer.isTheEnd;
end

function Lua_MonsterTrialPowerWindow:getAttributeInfo(prePower, curPower)
	local vo;
	local info;
	local desArr = Array();
	for k,v in ipairs(prePower) do
		vo = Lua_AttributesVo.new(v.name);
		info = {};
		info.show_name = vo.show_name;
		info.sort = vo.sort;
		info.prePower = v.value;
		info.curPower = curPower[k].value;
		desArr:add(info);
	end
	desArr:sort("sort", false);
	return desArr;
end

function Lua_MonsterTrialPowerWindow:dispose()
	DataCenter.newHeroActData:removePrePopupInfo();
	if self.allUpDesContainer ~= nil then
		self.allUpDesContainer:dispose();
		self.allUpDesContainer = nil;
	end
	if self.upDesContainer ~= nil then
		self.upDesContainer:dispose();
		self.upDesContainer = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_DesItem = class("Lua_DesItem", Lua_ListCell);
function Lua_DesItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_DesItem:buildShowItem()
	self:superCall("buildShowItem");

	self.preDes = UICreate.createLabel(self.content, "", -50, 0, 200, 30, 30);
	self.preDes.fontName = Lua_MyUISettings.huakangFontName;
	self.preDes.colorStr = Lua_ColorDefine.transColorStr("656565");
	self.preDes.pivot = Lua_WindowUtil.getPivot(3);
	self.preDes.alignmentValue = 3;
	self.preDes.name = "preDes";

	self.targetIcon = UICreate.createUIAtlasImage(self.content, "shop_atlas_1", "ui_sd_icon_01", 200, 0, 100, 30);

	self.curDes = UICreate.createLabel(self.content, "", 445, 0, 195, 30, 30);
	self.curDes.fontName = Lua_MyUISettings.huakangFontName;
	self.curDes.colorStr = Lua_ColorDefine.transColorStr("656565");
	self.curDes.pivot = Lua_WindowUtil.getPivot(5);
	self.curDes.alignmentValue = 4;
	self.curDes.name = "curDes";
end

function Lua_DesItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.preDes.text = LanUtil.formateStr("{1}：{2}", data.show_name, data.prePower);
	self.curDes.text = data.curPower;
end

function Lua_DesItem:getWidth()
	return self.targetIcon.width;
end

function Lua_DesItem:getHeight()
	return self.targetIcon.height;
end

function Lua_DesItem:dispose()
	if self.preDes ~= nil then
		self.preDes:dispose();
		self.preDes = nil;
	end
	if self.targetIcon ~= nil then
		self.targetIcon:dispose();
		self.targetIcon = nil;
	end
	if self.curDes ~= nil then
		self.curDes:dispose();
		self.curDes = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end