-- 魔神试炼排行奖励
Lua_MonsterTrialRewardPanel = class("Lua_MonsterTrialRewardPanel", Lua_DisplayObject);
function Lua_MonsterTrialRewardPanel:ctor(p)
	self:superCall("ctor", p, "MonsterTrialRewardPanel_skin");
end

function Lua_MonsterTrialRewardPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.allRankBg:SetDimensions(MainWinDefine.DEFAULT_WIDTH, 943 + self.adaptHeight);

	self.itemList = Lua_DragList.new(self.content, 688, 950 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.itemList:setListCell(Lua_MonsterTrialRewardItem, 688, 139, 1);
	self.itemList:setLocation(0, -134.5, 0);
	self.itemList:setCellSpacing(0, 10);

	self.btnHelp:addClickFuntion(self, self.onBtnHelpClick);

	self:addLuaEvent("UPDATE_MONSTERTRIAL_REWARD_INFO", self, self.updateRewardInfo);
	Lua_MsgUtil.callFunc("MONSTERTRIAL_EVENT", {eventType = 1});
end

function Lua_MonsterTrialRewardPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);

	self.allRankBg:SetDimensions(MainWinDefine.DEFAULT_WIDTH, 943 + adaptHeight);

	self.itemList:setContentRect(688, 950 + adaptHeight);
end

function Lua_MonsterTrialRewardPanel:updateRewardInfo()
	table.sort(DataCenter.newHeroActData.rankRewardInfoDic, function(a, b) return a.rank_left < b.rank_left end);
	self.itemList:setArrayData(DataCenter.newHeroActData.rankRewardInfoDic);
end

function Lua_MonsterTrialRewardPanel:onBtnHelpClick(go)
	local tipsData = { des = "这是奖励说明", posX = 160, posY = -95 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_MonsterTrialRewardPanel:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_MonsterTrialRewardItem = class("Lua_MonsterTrialRewardItem", Lua_ListCell);
function Lua_MonsterTrialRewardItem:ctor(p)
	self:superCall("ctor", p, "MonsterTrialRewardItem_skin");
end

function Lua_MonsterTrialRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rankNum = Lua_NumberImage.new(self.content);
	self.rankNum:setLocation(-282, 0, 0);
	self.rankNum.pivot = 0;
	self.rankNum.numOffsetX = -4;
	self.rankNum.numAtlas = "number";
	self.rankNum.preStr = "ui_djc_title_0";

	self.rewardList = Lua_DragList.new(self.content, 480, 112, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_ItemIconCell, 112, 112, 1);
	self.rewardList:setLocation(0, 0, 0);
	self.rewardList:setCellSpacing(10, 0);
	self:setSubList(self.rewardList);
end

function Lua_MonsterTrialRewardItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	if data.rank_right == 0 then
		self.rankBg:setAltas("arena_atlas_2", "ui_djc_window_004");
		self.rankNum.num = data.rank_left.."+";
	elseif data.rank_left == data.rank_right then
		self.rankBg:setAltas("arena_atlas_2", "ui_djc_window_00"..data.rank_left);
		self.rankNum.num = nil;
	else
		self.rankBg:setAltas("arena_atlas_2", "ui_djc_window_004");
		self.rankNum.num = data.rank_left.."-"..data.rank_right;
	end

	local showWidth = self.rankBg.width - 6;
	if self.rankNum.totalWidth >= showWidth then
		local ratioValue = showWidth / self.rankNum.totalWidth;
		self.rankNum:setScale(ratioValue, ratioValue);
	else
		self.rankNum:setScale(1, 1);
	end

	self.rewardList:setArrayData(data.tvoArr);
	if data.tvoArr:getSize() > 3 then
		self.rewardList:setContentRect(480, 112);
	else
		self.rewardList:setContentRect(122 * data.tvoArr:getSize(), 112);
	end
end

function Lua_MonsterTrialRewardItem:dispose()
	if self.rankNum ~= nil then
		self.rankNum:dispose();
		self.rankNum = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end