-- 七天登录（新英雄后台活动）
Lua_SevenDaySignInPanel = class("Lua_SevenDaySignInPanel", Lua_DisplayObject);
function Lua_SevenDaySignInPanel:ctor(p, skinName)
	self:superCall("ctor", p, skinName);
end

function Lua_SevenDaySignInPanel:buildShowItem()
	self:superCall("buildShowItem");

	-- self.curIndex = 1;
	self.sevenDayArr = Array();

	self.bg:SetDimensions(MainWinDefine.DEFAULT_WIDTH, 1280 + self.adaptHeight);

	self.tipsBtn:addClickFuntion(self, self.onTipsBtnClick);

	-- self:addLuaEvent("UPDATE_SELECT_INFO", self, self.updateSelectDayInfo);
	self:addLuaEvent("DRAW_SEVENDAY_REWARD", self, self.drawSevenDayReward);
	self:addLuaEvent("UPDATE_SEVENDAY_LOGIN_INFO", self, self.updateSignInInfo);
end

function Lua_SevenDaySignInPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);

	self.bg:SetDimensions(MainWinDefine.DEFAULT_WIDTH, 1280 + adaptHeight);
end

function Lua_SevenDaySignInPanel:setData(data)
	self.data = data;
	self:startTimer();
end

function Lua_SevenDaySignInPanel:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:addTimer("Lua_SevenDaySignInPanel", 1, self, self.updateLeftTime);
	end
end

function Lua_SevenDaySignInPanel:updateLeftTime()
	if self.data.residueTime <= 0 then
		self:endTimer();
	end
	self.leftTimeTxt.text = LanUtil.formateStr("剩余时间：{1}", Lua_TimeTransform.transSeconds16(self.data.residueTime, true, true, true));
end

function Lua_SevenDaySignInPanel:endTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.updateLeftTime);
	end
end

function Lua_SevenDaySignInPanel:onTipsBtnClick(go)
	local tipData = { des = self.data.help_des, posX = 175, posY = -120 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

-- function Lua_SevenDaySignInPanel:updateSelectDayInfo(data)
-- 	self.sevenDayArr[self.curIndex]:setFluxay(false);
-- 	self.curIndex = data.id;
-- 	self.sevenDayArr[self.curIndex]:setFluxay(true);
-- end

function Lua_SevenDaySignInPanel:drawSevenDayReward(day)
	if DataCenter.backstageActData:checkActIsEnd(self.data) then
		return;
	end
	Lua_ProxyManager.getProxy("Lua_NewHeroActivityProxy"):sDrawSevenDayLogin(self.data.actIdx, day);
end

function Lua_SevenDaySignInPanel:updateSignInInfo()
	local newHeroActData = DataCenter.newHeroActData;
	local sevenDayInfoDic = newHeroActData.sevenDayInfoDic;
	local canDrawIdx = newHeroActData.canDrawIdx;
	local day = #sevenDayInfoDic;
	local spaceX = 140;
	local spaceY = 110;
	local shiftValue = 35;
	local value = day % 2 == 0 and day or day + 1;
	local posX;
	local leftPosX = -(spaceX * day) / 4 - spaceX / 2 + Mathf.Abs((day - value) * shiftValue);
	local item;
	for i = 1, day do
		item = self.sevenDayArr[i];
		if item == nil then
			item = Lua_SevenDaySignInItem.new(self.content);
			self.sevenDayArr:add(item);
		end

		if i <= day / 2 then
			posX = i * spaceX + leftPosX;
			item:setLocation(posX, spaceY, 0);
		else
			posX = (i - day / 2) * spaceX + leftPosX;
			item:setLocation(posX, -spaceY, 0);
		end

		item:setData(sevenDayInfoDic[i]);
		-- if i == canDrawIdx then
		-- 	self.curIndex = i;
		-- 	item:setFluxay(true);
		-- else
		-- 	item:setFluxay(false);
		-- end
	end
end

function Lua_SevenDaySignInPanel:dispose()
	if self.sevenDayArr ~= nil then
		self.sevenDayArr:dispose();
		self.sevenDayArr:clear();
		self.sevenDayArr = nil;
	end
	-- self.curIndex = 1;
	self.data = nil;
	self:endTimer();

	self:superCall("dispose");
end





--------------------------------------------------





Lua_SevenDaySignInItem = class("Lua_SevenDaySignInItem", Lua_ListCell);
function Lua_SevenDaySignInItem:ctor(p)
	self:superCall("ctor", p, "SevenDaySignInItem_skin");
end

function Lua_SevenDaySignInItem:buildShowItem()
	self:superCall("buildShowItem");

	self.bg:addClickFuntion(self, self.onDrawRewardClick);
	self.itemBg:addClickFuntion(self, self.onPressClick);
end

function Lua_SevenDaySignInItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.rewardIcon:setAltas(self.data.tvo.atlas, self.data.tvo.sprite);
	self.countTxt.text = self.data.tvo.count;

	self:setFluxay(false);
	self:endTimer();
	
	if data.state == 1 then
		self.daytxt.text = "领取";
		self:setFluxay(true);
	elseif data.state == 2 then
		self.daytxt.text = "已领取";
	else
		local login_day = DataCenter.newHeroActData.login_day;
		if login_day + 1 == data.id then
			self:startTimer();
			self:updateDrawTime();
		else
			self.daytxt.text = LanUtil.formateStr("第{1}天", data.id);
		end
	end

	self.mask:setEnable(data.state == 2);
	self.receivedIcon:setEnable(data.state == 2);
end

function Lua_SevenDaySignInItem:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_SevenDaySignInItem", 1, self, self.updateDrawTime);
	end
end

function Lua_SevenDaySignInItem:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateDrawTime);
	end
end

function Lua_SevenDaySignInItem:updateDrawTime()
	local remainTime = DataCenter.newHeroActData.close_tick - DataCenter.roleData.serverTime;
	if remainTime <= 0 then
		self.daytxt.text = "领取"; -- 00:00:00
		self:endTimer();
		return;
	end
	self.daytxt.text = Lua_TimeTransform.transSeconds6(remainTime, true, true, true);
end

function Lua_SevenDaySignInItem:onDrawRewardClick(go)
	-- Lua_MsgUtil.callFunc("UPDATE_SELECT_INFO", self.data);

	if self.data.state == 1 then
		Lua_MsgUtil.callFunc("DRAW_SEVENDAY_REWARD", self.data.id);
	end
end

function Lua_SevenDaySignInItem:onPressClick()
	-- Lua_MsgUtil.callFunc("UPDATE_SELECT_INFO", self.data);

	if self.data.state == 1 then
		Lua_MsgUtil.callFunc("DRAW_SEVENDAY_REWARD", self.data.id);
	else
		DataCenter.packUtil:showItemInfo(self.data.tvo);
	end
end

function Lua_SevenDaySignInItem:setFluxay(showState)
	if showState then
		self.itemBg:setAltas("sevenday_altas", "Register_widget_04");
	else
		self.itemBg:setAltas("sevenday_altas", "Register_widget_05");
	end
end

function Lua_SevenDaySignInItem:dispose()
	self:endTimer();
	self.data = nil;

	self:superCall("dispose");
end