-- 商店热卖（新英雄后台活动）
Lua_ShopHotPanel = class("Lua_ShopHotPanel", Lua_DisplayObject);
function Lua_ShopHotPanel:ctor(p, skinName)
	self:superCall("ctor", p, skinName);
end

function Lua_ShopHotPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.bg:SetDimensions(MainWinDefine.DEFAULT_WIDTH, 1280 + self.adaptHeight);

	self.giftList = Lua_DragList.new(self.content, 660, 800 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.giftList:setListCell(Lua_ShopHotItem, 660, 160, 1);
	self.giftList:setCellSpacing(0, 10);
	self.giftList:setLocation(0, -135, 0);

	self.tipsBtn:addClickFuntion(self, self.onTipsBtnClick);

	self:addLuaEvent("BUY_SHOPHOT_GIFT", self, self.buyShopHotGift);
	self:addLuaEvent("UPDATE_SHOPHOT_INFO", self, self.updateShopHotInfo);
end

function Lua_ShopHotPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);

	self.bg:SetDimensions(MainWinDefine.DEFAULT_WIDTH, 1280 + adaptHeight);
	self.giftList:setContentRect(660, 800 + adaptHeight);
end

function Lua_ShopHotPanel:setData(data)
	self.data = data;
	self:startTimer();
end

function Lua_ShopHotPanel:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:addTimer("Lua_ShopHotPanel", 1, self, self.updateLeftTime);
	end
end

function Lua_ShopHotPanel:updateLeftTime()
	if self.data.residueTime <= 0 then
		self:endTimer();
	end
	self.leftTimeTxt.text = LanUtil.formateStr("剩余时间：{1}", Lua_TimeTransform.transSeconds16(self.data.residueTime, true, true, true));
end

function Lua_ShopHotPanel:endTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.updateLeftTime);
	end
end

function Lua_ShopHotPanel:buyShopHotGift(rechargeId)
	if DataCenter.backstageActData:checkActIsEnd(self.data) then
		return;
	end

	local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(rechargeId);
	DataCenter.sdkInterface:PointOut(1, tonumber(rechargeInfo.money), tonumber(rechargeInfo.money_type),
			tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
end

function Lua_ShopHotPanel:updateShopHotInfo()
	self.giftList:setArrayData(DataCenter.newHeroActData.shopHotArr);
end

function Lua_ShopHotPanel:onTipsBtnClick(go)
	local tipData = { des = self.data.help_des, posX = 175, posY = -120 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_ShopHotPanel:dispose()
	if self.giftList ~= nil then
		self.giftList:dispose();
		self.giftList = nil;
	end
	self.data = nil;
	self:endTimer();

	self:superCall("dispose");
end





--------------------------------------------------





Lua_ShopHotItem = class("Lua_ShopHotItem", Lua_ListCell);
function Lua_ShopHotItem:ctor(p)
	self:superCall("ctor", p, "ShopHotItem_skin");
end

function Lua_ShopHotItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 672, 112, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_ItemIconCell, 112, 112, 1);
	self.rewardList:setLocation(-310, -18, 0);
	self.rewardList:setRectPivot(3);
	self:setSubList(self.rewardList);

	self.buyBtn:addClickFuntion(self, self.onBuyBtnClick);
end

function Lua_ShopHotItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.tipsTxt.text = data.title;

	local curTimes = data.buy_limit - data.buy_times;
	self.limitTimesTxt.text = LanUtil.formateStr("限购：<color=#45BC56>{1}</color>", curTimes);

	self.rewardList:setArrayData(data.tvoArr);
	if data.tvoArr:getSize() > 4 then
		self.rewardList:setContentRect(112 * 4.1, 112);
	else
		self.rewardList:setContentRect(112 * data.tvoArr:getSize(), 112);
	end

	local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(self.data.recharge_id);
	self.buyBtn.label = LanUtil.formateStr("{1}元", tonumber(rechargeInfo.money));

	self.limitTimesTxt:setEnable(curTimes > 0);
	self.buyBtn:setEnable(curTimes > 0);
	self.sellOutSp:setEnable(curTimes <= 0);
end

function Lua_ShopHotItem:onBuyBtnClick()
	Lua_MsgUtil.callFunc("BUY_SHOPHOT_GIFT", self.data.recharge_id);
end

function Lua_ShopHotItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end