--新英雄主题活动 剧情关卡Panel
checkRequire("Lua_NewHeroStoryMenuPanel");
Lua_NewHeroActStoryPanel = class("Lua_NewHeroActStoryPanel", Lua_DisplayObject);
function Lua_NewHeroActStoryPanel:ctor(p, skinName)
    self:superCall("ctor", p, skinName);
end

function Lua_NewHeroActStoryPanel:buildPanel()
	self:superCall("buildPanel");

	self:addLuaEvent("NEWHERO_STORY_NEXTSTEP", self, self.toNextStep);
	self:addLuaEvent("RECEIVE_NEWHEROSTORY_REWARD", self, self.receiveReward);
	self:addLuaEvent("OPEN_NEWHERO_STORY_LINEUP", self, self.openLineupWin);
	self:addLuaEvent("SET_NEWHEROSTORY_LINEUP_INFO", self, self.setLineupInfo);
	self:addLuaEvent("UPDATE_NEWHERO_STORYINFO", self, self.updateStoryInfo);
end

function Lua_NewHeroActStoryPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content, 720, 700, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_NewHeroStoryChapterItem, 400, 235, 1);
	self.dragList:setSubOffect(160, 0);
    self.dragList:setLocation(0, 0, 0);

	self.tipIcon:addClickFuntion(self, self.onTipIconClick);
	self.recordBtn:addClickFuntion(self, self.onRecordBtnClick);
	self.rewardBtn:addClickFuntion(self, self.onRewardBtnClick);
end

function Lua_NewHeroActStoryPanel:dispose()
	self:removeTimer(self, self.onTimer);
	DataCenter.preLoadData:removeBySign("Lua_NewHeroActStoryLineupWindow", self, self.onSceneShow);

	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end

function Lua_NewHeroActStoryPanel:setData(data)
	self.data = data;
	self.titleTxt.text = data.title;

	self.time = data.endTick - DataCenter.roleData.serverTime + 1;
	self:onTimer();
end

function Lua_NewHeroActStoryPanel:onTimer()
	self.time = self.time - 1;
	if self.time <= 0 then
		self.time = 0;
	end
	self.timeTxt.text = LanUtil.formateStr("剩余时间：{1}", Lua_TimeTransform.transSeconds16(self.time, true, true, true));

	if self.time > 0 then
		if not self.isTimer then
			self.isTimer = true;
			self:addTimer("onTimer", 1, self, self.onTimer)
		end
	else
		if self.isTimer then
			self.isTimer = false;
			self:removeTimer(self, self.onTimer);
		end
	end
end

function Lua_NewHeroActStoryPanel:updateStoryInfo()
	DataCenter.newHeroActData.storyChapterArr:sort("chapterId", true);
	self.dragList:setArrayData(DataCenter.newHeroActData.storyChapterArr);
	self.dragList:setSelected(DataCenter.newHeroActData.defaultChapter);
end

function Lua_NewHeroActStoryPanel:toNextStep(levelVo)
	local showType = levelVo.state == 1 and 1 or 2;
	Lua_ProxyManager.getProxy("Lua_NewHeroActivityProxy"):sStoryNextStep(self.data.actIdx, levelVo.id, showType);
end

function Lua_NewHeroActStoryPanel:receiveReward(chapterId)
	Lua_ProxyManager.getProxy("Lua_NewHeroActivityProxy"):sStoryReward(self.data.actIdx, chapterId);
end

function Lua_NewHeroActStoryPanel:openLineupWin(param)
	local sceneId = DataCenter.heroLineupData:getFightLineupSceneId(Lua_FightDefine.TEMPLATE_ID_STORY);
	DataCenter.preLoadData:preShowScene("Lua_NewHeroActStoryLineupWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, param, sceneId, 0);
end

function Lua_NewHeroActStoryPanel:onSceneShow(param)
	local list = { template_id = Lua_FightDefine.TEMPLATE_ID_STORY, stage_id = param.id };
	Lua_WindowUtil.openWin("Lua_NewHeroActStoryLineupWindow", Lua_WinParam.ACTION_OPEN, list);
end

function Lua_NewHeroActStoryPanel:setLineupInfo(data)
	Lua_ProxyManager.getProxy("Lua_NewHeroActivityProxy"):sStoryLineup(self.data.actIdx, data.stage_id, data.stand_type, data.hero_lineup, data.artifact_list);
end

function Lua_NewHeroActStoryPanel:onTipIconClick(go)
	local tipsData = { des = self.data.help_des, posX = -230, posY = -180 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_NewHeroActStoryPanel:onRecordBtnClick(go)
	Lua_WindowUtil.openWin("Lua_NewHeroStoryRecordWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_NewHeroActStoryPanel:onRewardBtnClick(go)
	Lua_WindowUtil.openWin("Lua_NewHeroStoryRewardWindow", Lua_WinParam.ACTION_OPEN);
end





--------------------------------------------------





Lua_NewHeroStoryChapterItem = class("Lua_NewHeroStoryChapterItem", Lua_ListCell);
function Lua_NewHeroStoryChapterItem:ctor(p)
	self:superCall("ctor", p, "NewHeroStoryChapterItem_skin");
end

function Lua_NewHeroStoryChapterItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_NewHeroStoryChapterItem:dispose()
	self:superCall("dispose");
end

function Lua_NewHeroStoryChapterItem:setData(data)
	self.data = data;

	if data.state >= 2 then
		self.titleTxt.text = data.chapterTitle;
	elseif data.state == 1 then
		self.titleTxt.text = "未解锁";
	else
		self.titleTxt.text = LanUtil.formateStr("{1}开启", Lua_TimeTransform.transSeconds7(data.openTime));
	end

	if self.titleTxt.width ~= 0 then
		self.titleBg:SetDimensions(self.titleTxt.width + 60, 58);
	else
		self.titleBg:SetDimensions(135, 58);
	end

	if not data.isTheEnd then
		if data.state == 3 then
			self.progressBar:setMaxValue(1);
			self.progressBar:setValue(1);
		elseif data.state == 2 then
			self.progressBar:setMaxValue(data.LevelVoArr:getSize());
			self.progressBar:setValue(data.passLevelNum);
		else
			self.progressBar:setMaxValue(1);
			self.progressBar:setValue(0);
		end
		self.progressBar:setEnable(true);
	else
		self.progressBar:setEnable(false);
	end

	self.chapterIcon:setGray(data.state < 2);

	if self.showPanel ~= nil then
		self.showPanel:setData(data);
	end
end

function Lua_NewHeroStoryChapterItem:onPressClick()
	if self.data.state == 0 then
		OperateAlert.show("未达到章节解锁时间");
		return false;
	elseif self.data.state == 1 then
		OperateAlert.show("章节尚未解锁，请通关前置章节");
		return false;
	end
	return true;
end

function Lua_NewHeroStoryChapterItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val then
		if self.showPanel == nil then
			self.showPanel = Lua_NewHeroStoryMenuPanel.new(self.content);
			self.showPanel:setLocation(230, 0, 0);
		end
		self.showPanel:setData(self.data);
	end

	if self.showPanel ~= nil then
		self.showPanel:setEnable(val);
	end
	self.clickBg:setEnable(val);
end