--新英雄主题活动 作战记录Panel
Lua_NewHeroStoryRecordPanel = class("Lua_NewHeroStoryRecordPanel", Lua_DisplayObject);
function Lua_NewHeroStoryRecordPanel:ctor(p)
	self:superCall("ctor", p, "NewHeroStoryRecordPanel_skin");
end

function Lua_NewHeroStoryRecordPanel:buildPanel()
	self:superCall("buildPanel");
end

function Lua_NewHeroStoryRecordPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content, 720, 960, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_NewHeroStoryRecordItem, 720, 400, 1);
	self.dragList:setLocation(0, -130, 0);
	self.dragList:setCellSpacing(0, 10);
end

function Lua_NewHeroStoryRecordPanel:updateData()
	local recordList = DataCenter.newHeroActData.recordList;
	self.dragList:setArrayData(recordList);
	self.noneObject:SetActive(#recordList <= 0);
end

function Lua_NewHeroStoryRecordPanel:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_NewHeroStoryRecordItem = class("Lua_NewHeroStoryRecordItem", Lua_ListCell);
function Lua_NewHeroStoryRecordItem:ctor(p)
	self:superCall("ctor", p, "NewHeroStoryRecordItem_skin");
end

function Lua_NewHeroStoryRecordItem:buildShowItem()
	self:superCall("buildShowItem");

	self.leftAvatar = Lua_AvatarItem.new(self.content);
	self.leftAvatar:setLocation(-280, 30, 0);
	self.leftAvatar:setScale(0.8, 0.8, 0.8);

	self.leftPanel = Lua_HeroGridViewPanel.new(self.content);
	self.leftPanel:setLocation(-130, -45, 0);
	self.leftPanel:setLayout(2, 0);
	self.leftPanel:setGridCell(73, 73);

	self.rightPanel = Lua_HeroGridViewPanel.new(self.content);
	self.rightPanel:setLocation(130, -45, 0);
	self.rightPanel:setLayout(2, 0);
	self.rightPanel:setGridCell(73, 73);

	self.detailBtn:addClickFuntion(self, self.onDetailBtnClick);
end

function Lua_NewHeroStoryRecordItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.nameTxt.text = data.att_player.name;
	self.levelTxt.text = data.title;
	
	if data.win_type == 1 then
		self.resultTxt.text = LanUtil.formateStr("{1}VS{2}", "胜", "败");
	else
		self.resultTxt.text = LanUtil.formateStr("{1}VS{2}", "败", "胜");
	end

	self.leftAvatar:setRoleId(data.att_player.id);
	self.leftAvatar:setRoleAvatar(data.att_player.head_id);
	self.leftAvatar:setRoleLevel(data.att_player.level);

	self.leftPanel:setDataByProto(data.att_lineup);
	self.rightPanel:setDataByProto(data.def_lineup);
end

function Lua_NewHeroStoryRecordItem:onDetailBtnClick()
	Lua_WindowUtil.openWin("Lua_FightOverallHurtWindow", Lua_WinParam.ACTION_OPEN, self.data.hurt_collect_list);
end

function Lua_NewHeroStoryRecordItem:dispose()
	if self.leftAvatar ~= nil then
		self.leftAvatar:dispose();
		self.leftAvatar = nil;
	end
	if self.leftPanel ~= nil then
		self.leftPanel:dispose();
		self.leftPanel = nil;
	end
	if self.rightPanel ~= nil then
		self.rightPanel:dispose();
		self.rightPanel = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end