--新英雄主题活动 剧情回顾Panel
Lua_NewHeroStoryReviewPanel = class("Lua_NewHeroStoryReviewPanel", Lua_DisplayObject);
function Lua_NewHeroStoryReviewPanel:ctor(p)
    self:superCall("ctor", p);
end

function Lua_NewHeroStoryReviewPanel:buildPanel()
	self:superCall("buildPanel");

	self:addLuaEvent("UPDATE_NEWHERO_STORYINFO", self, self.updateData);
end

function Lua_NewHeroStoryReviewPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.titleTxt = UICreate.createLabel(self.content, "", -190, 525, 250, 50, 50);
	self.titleTxt.fontName = Lua_MyUISettings.huakangFontName;
	self.titleTxt.alignmentValue = 3;
	self.titleTxt.text = "剧情回顾";

	self.customBtnList = Lua_DragCustomBtnList.new(self.content, Lua_AxisDefine.Vertical, 720, 875);
	self.customBtnList:setLocation(0, -155, 0);
	self.customBtnList:setMainCell(Lua_NewHeroStoryMainCell, 0, 120, 0, 875 / 2);
	self.customBtnList:setSubCell(Lua_NewHeroStorySubCell, 0, 120, 0, 875 / 2);
	self.customBtnList.clickDrawBack = true;
end

function Lua_NewHeroStoryReviewPanel:updateData()
	DataCenter.newHeroActData.storyChapterArr:sort("chapterId", false);
	local storyChapterArr = DataCenter.newHeroActData.storyChapterArr;
	local arr = Array();
	local subDataArr;
	for i = 1, storyChapterArr:getSize() do
		subDataArr = storyChapterArr[i].LevelVoArr; -- 关卡信息
		arr:add({ mainDataArr = storyChapterArr[i], subData = subDataArr });
	end
	self.customBtnList:setData(arr);
end

function Lua_NewHeroStoryReviewPanel:dispose()
	if self.customBtnList ~= nil then
		self.customBtnList:dispose();
		self.customBtnList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_NewHeroStoryMainCell = class("Lua_NewHeroStoryMainCell", Lua_DragCustomBtnListCell);
function Lua_NewHeroStoryMainCell:ctor(p, btnType, cellWidth, cellHeight, offsetX, offsetY)
	self:superCall("ctor", p, btnType, cellWidth, cellHeight, offsetX, offsetY, "NewHeroStoryMainCell_skin");
end

function Lua_NewHeroStoryMainCell:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_NewHeroStoryMainCell:updateData()
	self.titleTxt.text = self.data.mainDataArr.chapterTitle;
	self.contentTxt.text = self.data.mainDataArr.chapterContent;
end

function Lua_NewHeroStoryMainCell:onPressClick()
	self:superCall("onPressClick");

	DataCenter.newHeroActData.selectChapter = self.data.mainDataArr.chapterId;
end

function Lua_NewHeroStoryMainCell:setSelected(val)
	self:superCall("setSelected", val);

	if val == true then
		self.signIcon:setScale(1, -1, 1);
	else
		self.signIcon:setScale(1, 1, 1);
	end
end

function Lua_NewHeroStoryMainCell:dispose()
	self:superCall("dispose");
end





--------------------------------------------------





Lua_NewHeroStorySubCell = class("Lua_NewHeroStorySubCell", Lua_DragCustomBtnListCell);
function Lua_NewHeroStorySubCell:ctor(p, btnType, cellWidth, cellHeight, offsetX, offsetY)
	self:superCall("ctor", p, btnType, cellWidth, cellHeight, offsetX, offsetY, "NewHeroStorySubCell_skin");
end

function Lua_NewHeroStorySubCell:buildShowItem()
	self:superCall("buildShowItem");

	self.viewBtn:addClickFuntion(self, self.onViewBtnClick);
end

function Lua_NewHeroStorySubCell:updateData()
	self.titleTxt.text = self.data.title;
	self.lockTxt.text = LanUtil.formateStr("通关{1}解锁", self.data.name);

	self.viewBtn:setEnable(self.data.state == 3);
	self.lockTxt:setEnable(self.data.state ~= 3);
end

function Lua_NewHeroStorySubCell:onViewBtnClick(go)
	Lua_WindowUtil.openWin("Lua_NewHeroStoryPlayWindow", Lua_WinParam.ACTION_OPEN, self.data); -- 播放剧情
end

function Lua_NewHeroStorySubCell:dispose()
	self:superCall("dispose");
end