--新英雄主题活动 章节奖励Window
Lua_NewHeroStoryRewardWindow = class("Lua_NewHeroStoryRewardWindow", Lua_Window);
function Lua_NewHeroStoryRewardWindow:ctor()
	self:superCall("ctor");

	self.showBlackMask = true;
	self.isClickClose = true;
	self.showClose = true;
	self.windowName = "Lua_NewHeroStoryRewardWindow";
	self.skinName = "NewHeroStoryRewardWindow_skin";
end

function Lua_NewHeroStoryRewardWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	self:addLuaEvent("UPDATE_NEWHERO_STORYINFO", self, self.updateInfo);
end

function Lua_NewHeroStoryRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.btnClose:setLocation(293, 405);

	self.dragList = Lua_DragList.new(self.content, 640, 750, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_NewHeroStoryRewardItem, 640, 180, 1);
	self.dragList:setLocation(0, -25, 0);
	self.dragList:setCellSpacing(0, 10);

	self:updateInfo();
end

function Lua_NewHeroStoryRewardWindow:updateInfo()
	self.dragList:setArrayData(DataCenter.newHeroActData.chapterRewardArr);
end

function Lua_NewHeroStoryRewardWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_NewHeroStoryRewardItem = class("Lua_NewHeroStoryRewardItem", Lua_ListCell);
function Lua_NewHeroStoryRewardItem:ctor(p)
	self:superCall("ctor", p, "NewHeroStoryRewardItem_skin");
end

function Lua_NewHeroStoryRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 250, 112, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_ItemIconCell, 112, 112, 1);
	self.rewardList:setLocation(77, -25, 0);
	self.rewardList:setCellSpacing(10, 0);
	self.rewardList:setRectAnchor(3);
	self:setSubList(self.rewardList);

	self.receiveBtn:addClickFuntion(self, self.onReceiveBtnClick);
end

function Lua_NewHeroStoryRewardItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	local chapterVo = DataCenter.newHeroActData:getChapterVo(data.index);
	self.titleTxt.text = chapterVo.chapterTitle;

	self.rewardList:setArrayData(data.tvoArr);
	if data.tvoArr:getSize() > 3 then
		self.rewardList:setContentRect(420, 112);
	else
		self.rewardList:setContentRect(data.tvoArr:getSize() * 112, 112);
	end

	if data.state == 0 then
		self.receiveBtn.label = "未达成";
	elseif data.state == 1 then
		self.receiveBtn.label = "领取";
	end

	self.receiveBtn:setEnable(data.state ~= 2);
	self.receivedIcon:setEnable(data.state == 2);
end

function Lua_NewHeroStoryRewardItem:onReceiveBtnClick(go)
	if self.data.state == 0 then
		OperateAlert.show("目标尚未达成");
	elseif self.data.state == 1 then
		local chapterVo = DataCenter.newHeroActData:getChapterVo(self.data.index);
		Lua_MsgUtil.callFunc("RECEIVE_NEWHEROSTORY_REWARD", chapterVo.chapterId)
	end
end

function Lua_NewHeroStoryRewardItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end