-- 升星专属（周期）（新英雄后台活动）
Lua_NewHeroUpStarPanel = class("Lua_NewHeroUpStarPanel", Lua_DisplayObject);
function Lua_NewHeroUpStarPanel:ctor(p, skinName)
	self:superCall("ctor", p, skinName);
end

function Lua_NewHeroUpStarPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.bg:SetDimensions(MainWinDefine.DEFAULT_WIDTH, 1280 + self.adaptHeight);

	self.money = Lua_MoneyItem.new(self.content);
	self.money:setMoneyType(Lua_ResourcesDefine.GOLD);
	self.money:setRectAnchor(1);
	self.money:setCanClick(true);
	self.money:setLocation(117, -24, 0);

	self.diamond = Lua_MoneyItem.new(self.content);
	self.diamond:setMoneyType(Lua_ResourcesDefine.DIAMOND);
	self.diamond:setRectAnchor(1);
	self.diamond:setCanClick(true);
	self.diamond:setLocation(278, -24, 0);

	self.giftList = Lua_DragList.new(self.content, 680, 780 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.giftList:setListCell(Lua_NewHeroUpStarRewardItem, 680, 130, 1);
	self.giftList:setLocation(0, -155, 0);

	self.tipsBtn:addClickFuntion(self, self.onTipsBtnClick);
	self.gotoRecruitBtn:addClickFuntion(self, self.onGotoRecruitClick);

	self:addLuaEvent("DRAW_NERHERO_UPSTAR_REWARD", self, self.drawNewHeroUpStarReward);
    self:addLuaEvent("UPDATE_NEWHERO_UPSTAR_INFO", self, self.updateNewHeroUpStarInfo);
end

function Lua_NewHeroUpStarPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
	
	self.bg:SetDimensions(MainWinDefine.DEFAULT_WIDTH, 1280 + adaptHeight);
	self.giftList:setContentRect(680, 780 + adaptHeight);
end

function Lua_NewHeroUpStarPanel:setData(data)
	self.data = data;
	self:startTimer();
end

function Lua_NewHeroUpStarPanel:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_NewHeroUpStarPanel", 1, self, self.updateLeftTime);
	end
end

function Lua_NewHeroUpStarPanel:updateLeftTime()
	if self.data.residueTime <= 0 then
		self.leftTimesTxt.text = "00时00分00秒";
		self:endTimer();
		return;
	end
	self.leftTimesTxt.text = Lua_TimeTransform.transSeconds18(self.data.residueTime, true, true, true, false);
end

function Lua_NewHeroUpStarPanel:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateLeftTime);
	end
end

function Lua_NewHeroUpStarPanel:onTipsBtnClick(go)
    local tipData = { des = self.data.help_des, posX = 200, posY = 620 };
    Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_NewHeroUpStarPanel:onGotoRecruitClick(go)
	if DataCenter.backstageActData:checkActIsEnd(self.data) then
		return;
	end
	DataCenter.funcPathUtil:gotoFunction(DataCenter.newHeroActData.eventId, true)
end

function Lua_NewHeroUpStarPanel:drawNewHeroUpStarReward(giftId)
	if DataCenter.backstageActData:checkActIsEnd(self.data) then
		return;
	end
	Lua_ProxyManager.getProxy("Lua_NewHeroActivityProxy"):sDrawUpStarReward(giftId, self.data.actIdx);
end

function Lua_NewHeroUpStarPanel:updateNewHeroUpStarInfo()
	self.giftList:setArrayData(DataCenter.newHeroActData.rewardInfoArr);
end

function Lua_NewHeroUpStarPanel:dispose()
	if self.money ~= nil then
		self.money:dispose();
		self.money = nil;
	end
	if self.diamond ~= nil then
		self.diamond:dispose();
		self.diamond = nil;
	end
	if self.giftList ~= nil then
		self.giftList:dispose();
		self.giftList = nil;
	end
	self:endTimer();

	self:superCall("dispose");
end





--------------------------------------------------





Lua_NewHeroUpStarRewardItem = class("Lua_NewHeroUpStarRewardItem", Lua_ListCell);
function Lua_NewHeroUpStarRewardItem:ctor(p)
	self:superCall("ctor", p, "NewHeroUpStarRewardItem_skin");
end

function Lua_NewHeroUpStarRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.heroIcon = Lua_ItemIcon.new(self.content);
	self.heroIcon:setLocation(-270, 0);
	self.heroIcon:setSiblingIndex(1);

	self.freeIcon = Lua_ItemIcon.new(self.content);
	self.freeIcon:setLocation(-140, 0);
	self.freeIcon:setSiblingIndex(2);

	self.rewardList = Lua_DragList.new(self.content, 240, 115, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_RechargeRewardItem, 112, 112, 1);
	self.rewardList:setLocation(55, -2, 0);
	self:setSubList(self.rewardList);

	self.rechargeBtn:addClickFuntion(self, self.onRechargeClick);
end

function Lua_NewHeroUpStarRewardItem:setData(data)
	if data == nil then
		return;
	end
	self.data = data;

	local newHeroActData = DataCenter.newHeroActData;
	local curShowHero = Lua_ToolVo.createToolVo(newHeroActData.heroId);
	curShowHero.star = data.star;
	self.heroIcon:setData(curShowHero);

	self.freeIcon:setData(data.freeInfo.tvoArr[1]);
	-- self.freeIcon:showText(4, data.freeInfo.tvoArr[1].count);

	local rechargeInfo = data.rechargeInfo;
	self.rechargeBtn.label = LanUtil.formateStr("{1}元", Mathf.Floor(rechargeInfo.recharge));
	self.limitCountTxt.text = LanUtil.formateStr("限购：{1}/{2}", rechargeInfo.curr_times, rechargeInfo.limit_times);
	
	local rewardInfo = Array();
	local vo;
	for i = 1, rechargeInfo.tvoArr:getSize() do
		vo = {};
		vo.itemInfo = rechargeInfo.tvoArr[i];
		vo.curr_times = rechargeInfo.curr_times;
		rewardInfo:add(vo);
	end
	self.rewardList:setArrayData(rewardInfo);
	self.rewardList.canDrag = rewardInfo:getSize() >= 3;

	local curPlayerHeroInfo = newHeroActData.curPlayerHeroInfo;
	if curPlayerHeroInfo == nil then
		self.mask:setEnable(true);
		-- self.freeIcon:showEffect(false);
		self.rechargeBtn:setStyle(3);
	else
		self.mask:setEnable(data.star > curPlayerHeroInfo.star);
		-- self.freeIcon:showEffect(data.star <= curPlayerHeroInfo.star);
		self.rechargeBtn:setStyle(data.star > curPlayerHeroInfo.star and 3 or 1);
	end

	self.receiveIcon:setEnable(data.freeInfo.curr_times <= 0);
	self.rechargeBtn:setEnable(rechargeInfo.curr_times > 0);
	self.sellOutIcon:setEnable(rechargeInfo.curr_times <= 0);
	self.limitCountTxt:setEnable(rechargeInfo.curr_times > 0);
end

function Lua_NewHeroUpStarRewardItem:onPressClick()
	local winPos = LuaUtil.getTouchPosInverseObj(self.mainContent);
	if self.freeIcon:checkInBound(winPos.x, winPos.y) then
		self:onBtnClick();
	end
end

function Lua_NewHeroUpStarRewardItem:onBtnClick()
	local curPlayerHeroInfo = DataCenter.newHeroActData.curPlayerHeroInfo;
	if curPlayerHeroInfo ~= nil and curPlayerHeroInfo.star >= self.data.star and self.data.freeInfo.curr_times > 0 then
		Lua_MsgUtil.callFunc("DRAW_NERHERO_UPSTAR_REWARD", self.data.freeInfo.gift_id);
	else
		DataCenter.packUtil:showItemInfo(self.freeIcon.data);
	end
end

function Lua_NewHeroUpStarRewardItem:onRechargeClick(go)
	local curPlayerHeroInfo = DataCenter.newHeroActData.curPlayerHeroInfo;
	if curPlayerHeroInfo ~= nil and curPlayerHeroInfo.star >= self.data.star and self.data.rechargeInfo.curr_times > 0 then
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(self.data.rechargeInfo.gift_id);
		DataCenter.sdkInterface:PointOut(1, tonumber(rechargeInfo.money), tonumber(rechargeInfo.money_type),
				tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
	else
		OperateAlert.show(LanUtil.formateStr("{1}升至{2}星可解锁", self.heroIcon.data.name, self.data.star));
	end
end

function Lua_NewHeroUpStarRewardItem:dispose()
	if self.heroIcon ~= nil then
		self.heroIcon:dispose();
		self.heroIcon = nil;
	end
	if self.freeIcon ~= nil then
		self.freeIcon:dispose();
		self.freeIcon = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_RechargeRewardItem = class("Lua_RechargeRewardItem", Lua_ListCell);
function Lua_RechargeRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_RechargeRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rechargeIcon = Lua_ItemIcon.new(self.content);
	self.rechargeIcon:setSiblingIndex(0);

	self.receiveIcon = UICreate.createUIAtlasImage(self.content, "excellentActivity_atlas", "receiveIcon", -1, 1, 0, 0);
end

function Lua_RechargeRewardItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.rechargeIcon:setData(data.itemInfo);
	-- self.rechargeIcon:showText(4, data.itemInfo.count);

	self.receiveIcon:setEnable(data.curr_times <= 0);
end

function Lua_RechargeRewardItem:onPressClick(go)
	DataCenter.packUtil:showItemInfo(self.rechargeIcon.data);
end

function Lua_RechargeRewardItem:dispose()
	if self.rechargeIcon ~= nil then
		self.rechargeIcon:dispose();
		self.rechargeIcon = nil;
	end
	if self.receiveIcon ~= nil then
		self.receiveIcon:dispose();
		self.receiveIcon = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end