Lua_WarCoinLvItem = class("Lua_WarCoinLvItem", Lua_ListCell);
function Lua_WarCoinLvItem:ctor(p)
	self:superCall("ctor", p, "WarCoinLvItem_skin");
end

function Lua_WarCoinLvItem:buildShowItem()
	self:superCall("buildShowItem");

	self.freeIcons = Lua_ItemIconList.new(self.content);
	self.freeIcons:setLocation(-148, 0, 0);
	self.freeIcons:setSiblingIndex(4);
	self.freeIcons:setLayout(115, 0, 2);
	self.freeIcons.pivot = 1;

	self.rechargeList = Lua_DragList.new(self.content, 230, 112, Lua_AxisDefine.Horizontal);
	self.rechargeList:setListCell(Lua_WarCoinRechargeItem, 112, 112, 1);
	self.rechargeList:setLocation(30, 0, 0);
	self.rechargeList:setRectPivot(3);
	self.rechargeList:setSiblingIndex(6);
	self:setSubList(self.rechargeList);
end

function Lua_WarCoinLvItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.levelTxt.text = data.level;

	self.freeIcons:setArrayData(data.ordinaryRewards);
	if data.reward_state == 1 then
		self.freeIcons:setClick(self, self.onRewarClick);
	else
		self.freeIcons:setClick(nil, nil);
	end

	self.rechargeList:setArrayData(data.advancedRewards);
	if data.advancedRewards:getSize() > 2 then
		self.rechargeList:setContentRect(240, 112);
	else
		self.rechargeList:setContentRect(data.advancedRewards:getSize() * 115, 112);
	end

	self.freeIcons:setItemDrawMaskState(data.reward_state == 2);
	self.seniorRewardMask:setEnable(DataCenter.newHeroActData.level < data.level);
	self.lockObj:SetActive(DataCenter.newHeroActData.recharge_state == 0 or data.level > DataCenter.newHeroActData.level);
	local redDotState = data.reward_state == 1 or (DataCenter.newHeroActData.recharge_state == 1 and data.stage_reward_state == 1);
	self:showRedDot(redDotState)
end

function Lua_WarCoinLvItem:onPressClick()
	self.freeIcons:onBoundClick();
end

function Lua_WarCoinLvItem:onRewarClick()
	-- print("执行回调，领取或显示物品信息", self.data.reward_state);
	local winPos = LuaUtil.getTouchPosInverseObj(self.freeIcons.mainContent);
	for i = 1, self.freeIcons.showArr:getSize() do
		if self.freeIcons.showArr[i]:checkInBound(winPos.x, winPos.y) then
			if self.data.reward_state == 1 then
				Lua_MsgUtil.callFunc("DRAW_WARCOIN_REWARD", {eventType = 1, level = self.data.level, type = 1});
			end
		end
	end
end

function Lua_WarCoinLvItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(310, 55, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_WarCoinLvItem:dispose()
	if self.freeIcons ~= nil then
		self.freeIcons:dispose();
		self.freeIcons = nil;
	end
	if self.rechargeList ~= nil then
		self.rechargeList:dispose();
		self.rechargeList = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_WarCoinRechargeItem = class("Lua_WarCoinRechargeItem", Lua_ListCell);
function Lua_WarCoinRechargeItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_WarCoinRechargeItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardIcon = Lua_ItemIcon.new(self.content);
end

function Lua_WarCoinRechargeItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.rewardIcon:setData(data.tvo);
	self:setDrawMask(data.stage_reward_state == 2);
end

function Lua_WarCoinRechargeItem:onPressClick()
	if DataCenter.newHeroActData.recharge_state == 1 and self.data.stage_reward_state == 1 then
		Lua_MsgUtil.callFunc("DRAW_WARCOIN_REWARD", {eventType = 1, level = self.data.level, type = 2});
	else
		DataCenter.packUtil:showItemInfo(self.data.tvo);
	end
end

function Lua_WarCoinRechargeItem:setDrawMask(bState)
	if bState then
		if self.drawMask == nil then
			self.drawMask = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_window_014", 0, 0, 0, 0);
		end
		self.drawMask:setEnable(true);
	else
		if self.drawMask ~= nil then
			self.drawMask:setEnable(false);
		end
	end
end

function Lua_WarCoinRechargeItem:dispose()
	if self.rewardIcon ~= nil then
		self.rewardIcon:dispose();
		self.rewardIcon = nil;
	end
	if self.drawMask ~= nil then
		self.drawMask:dispose();
		self.drawMask = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end