-- 战令（新英雄后台活动）
checkRequire("Lua_WarCoinLvItem");
Lua_WarCoinPanel = class("Lua_WarCoinPanel", Lua_DisplayObject);
function Lua_WarCoinPanel:ctor(p, skinName)
	self:superCall("ctor", p, skinName);
end

function Lua_WarCoinPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.bg:SetDimensions(MainWinDefine.DEFAULT_WIDTH, 1280 + self.adaptHeight);

	self.money = Lua_MoneyItem.new(self.content);
	self.money:setMoneyType(Lua_ResourcesDefine.GOLD);
	self.money:setRectAnchor(1);
	self.money:setCanClick(true);
	self.money:setLocation(117, -24, 0);

	self.diamond = Lua_MoneyItem.new(self.content);
	self.diamond:setMoneyType(Lua_ResourcesDefine.DIAMOND);
	self.diamond:setRectAnchor(1);
	self.diamond:setCanClick(true);
	self.diamond:setLocation(278, -24, 0);

	self.tabList = Array();
	self.tabList:add({ textStr = "等级奖励" }); -- redPointId = "redPointId"
	self.tabList:add({ textStr = "战令任务" }); -- redPointId = "redPointId"

	self.buttonList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.buttonList:setRectAnchor(1);
	self.buttonList:setLocation(-180, -490, 0);
	self.buttonList:setButtonStyle("common_altas_1", "ui_common_button_041_n", "ui_common_button_041_p", 150, 55, 1, 1);
	self.buttonList:setButtonItem(150, 55);
	-- self.buttonList:setRedPoint(72, 30);
	self.buttonList:setData(self.tabList);
	self.buttonList:setClickCallBack(self, self.onBtnClick);

	self.tipsBtn:addClickFuntion(self, self.onTipsBtnClick);
	self.buyLvBtn:addClickFuntion(self, self.onBuyLvClick);
	self.lockBtn:addClickFuntion(self, self.onLockBtnClick);

	self:addLuaEvent("DRAW_WARCOIN_REWARD", self, self.drawWarCoinReward);
	self:addLuaEvent("UPDATE_WARCOIN_INFO", self, self.updateWarCoinInfo);
end

function Lua_WarCoinPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);

	self.bg:SetDimensions(MainWinDefine.DEFAULT_WIDTH, 1280 + adaptHeight);

	if self.levelList ~= nil then
		self.levelList:setContentRect(660, 570 + adaptHeight);
	end
	if self.taskList ~= nil then
		self.taskList:setContentRect(640, 730 + adaptHeight);
	end
end

function Lua_WarCoinPanel:setData(data)
	self.data = data;
	self:startTimer();
end

function Lua_WarCoinPanel:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:addTimer("Lua_WarCoinPanel", 1, self, self.updateLeftTime);
	end
end

function Lua_WarCoinPanel:updateLeftTime()
	if self.data.residueTime <= 0 then
		self:endTimer();
	end
	self.leftTimeTxt.text = LanUtil.formateStr("剩余时间：{1}", Lua_TimeTransform.transSeconds16(self.data.residueTime, true, true, true));
end

function Lua_WarCoinPanel:endTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.updateLeftTime);
	end
end

function Lua_WarCoinPanel:onBtnClick(val)
	if self.index ~= val then
		if val == 1 then
			if self.levelList == nil then
				self.levelList = Lua_DragList.new(self.content, 660, 570 + self.adaptHeight, Lua_AxisDefine.Vertical);
				self.levelList:setListCell(Lua_WarCoinLvItem, 660, 139, 1);
				self.levelList:setCellSpacing(0, 10);
				self.levelList:setLocation(0, -160, 0);
			end

			self.levelList:setEnable(true);
			if self.taskList ~= nil then
				self.taskList:setEnable(false);
			end
		else
			if self.taskList == nil then
				self.taskList = Lua_DragList.new(self.content, 650, 730 + self.adaptHeight, Lua_AxisDefine.Vertical);
				self.taskList:setListCell(Lua_WarCoinTaskItem, 320, 200, 2);
				self.taskList:setCellSpacing(10, 10);
				self.taskList:setLocation(0, -170, 0);
			end

			self.taskList:setEnable(true);
			if self.levelList ~= nil then
				self.levelList:setEnable(false);
			end
		end
		self.explainObj:SetActive(val == 1);
		self.lockBtn:setEnable(val == 1);
	end
	self.index = val;

	self:updateShowInfo();
end

function Lua_WarCoinPanel:updateWarCoinInfo()
	self.buttonList.selectedIdx = nil;
	self.buttonList:setSelected(self.index == nil and 1 or self.index);
end

function Lua_WarCoinPanel:updateShowInfo()
	local newHeroActData = DataCenter.newHeroActData;
	self.levelTxt.text = newHeroActData.level;
	local tab = {newHeroActData.cur_exe_process, newHeroActData.exe};
	self.progressBar:setText(table.concat(tab, "/"));
	self.progressBar:setMaxValue(newHeroActData.exe);
	self.progressBar:setValue(newHeroActData.cur_exe_process);

	if self.index == 1 then
		self.lockIcon:setEnable(newHeroActData.recharge_state == 0);
		self.levelList:setArrayData(newHeroActData.warCoinRewardDic);
		
		if newHeroActData.recharge_state == 1 then
			self.lockBtn.label = "已解锁";
		else
			local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(newHeroActData.warCoinRechargeId);
			self.lockBtn.label = LanUtil.formateStr("{1}元解锁", tonumber(rechargeInfo.money));
		end
		self.lockBtn:setStyle(newHeroActData.recharge_state == 1 and 3 or 1);
	elseif self.index == 2 then
		self.taskList:setArrayData(newHeroActData.warCoinTaskArr);
	end

	self.buyLvBtn:setStyle(newHeroActData.cur_exe_process >= newHeroActData.exe and 3 or 1);
end

function Lua_WarCoinPanel:onTipsBtnClick(go)
	local tipData = { des = self.data.help_des, posX = 175, posY = -120 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_WarCoinPanel:onBuyLvClick(go)
	if DataCenter.backstageActData:checkActIsEnd(self.data) then
		return;
	end

	local newHeroActData = DataCenter.newHeroActData;
	if newHeroActData.cur_exe_process >= newHeroActData.exe then
		OperateAlert.show("战令等级已经达到最高级");
	else
		local str = spliceIconStrById(newHeroActData.up_level_item.key);
		local tipsData = {
			des = LanUtil.formateStr("<color=#846651>是否确认花费{1}{2}购买一级战令等级?</color>", str, tostring(newHeroActData.up_level_item.value)),
			posY = 70,
			btnType = 1,
			owner = self,
			sureFun = self.sBuyWarCoinLv
		};
		Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
	end
end

function Lua_WarCoinPanel:sBuyWarCoinLv()
	local costCount = DataCenter.packData:getItemCountById(DataCenter.newHeroActData.up_level_item.key);
	if costCount > DataCenter.newHeroActData.up_level_item.value then
		Lua_ProxyManager.getProxy("Lua_NewHeroActivityProxy"):sUpgradeOfWarCoin(self.data.actIdx);
	else
		local tvo = Lua_ToolVo.createToolVo(DataCenter.newHeroActData.up_level_item.key);
		OperateAlert.show(LanUtil.formateStr("{1}数量不满足购买所需", tvo.name));
	end
end

function Lua_WarCoinPanel:onLockBtnClick(go)
	if DataCenter.backstageActData:checkActIsEnd(self.data) then
		return;
	end
	
	if DataCenter.newHeroActData.recharge_state == 1 then
		OperateAlert.show("高级奖励已解锁");
	else
		Lua_WindowUtil.openWin("Lua_WarCoinRewardWindow", Lua_WinParam.ACTION_OPEN);
	end
end

function Lua_WarCoinPanel:drawWarCoinReward(data)
	if DataCenter.backstageActData:checkActIsEnd(self.data) then
		return;
	end

	if data.eventType == 1 then
		Lua_ProxyManager.getProxy("Lua_NewHeroActivityProxy"):sDrawWarCoinReward(self.data.actIdx, data.level, data.type);
	elseif data.eventType == 2 then
		Lua_ProxyManager.getProxy("Lua_NewHeroActivityProxy"):sDrawWarCoinExp(self.data.actIdx, data.task_id)
	end
end

function Lua_WarCoinPanel:dispose()
	if self.money ~= nil then
		self.money:dispose();
		self.money = nil;
	end
	if self.diamond ~= nil then
		self.diamond:dispose();
		self.diamond = nil;
	end
	if self.tabList ~= nil then
		self.tabList:dispose();
		self.tabList:clear();
		self.tabList = nil;
	end
	if self.buttonList ~= nil then
		self.buttonList:dispose();
		self.buttonList = nil;
	end
	if self.levelList ~= nil then
		self.levelList:dispose();
		self.levelList = nil;
	end
	if self.taskList ~= nil then
		self.taskList:dispose();
		self.taskList = nil;
	end
	self.data = nil;
	self:endTimer();

	self:superCall("dispose");
end





--------------------------------------------------





Lua_WarCoinTaskItem = class("Lua_WarCoinTaskItem", Lua_ListCell);
function Lua_WarCoinTaskItem:ctor(p)
	self:superCall("ctor", p, "WarCoinTaskItem_skin");
end

function Lua_WarCoinTaskItem:buildShowItem()
	self:superCall("buildShowItem");

	self.expIcon = Lua_ItemIcon.new(self.content);
	self.expIcon:setSiblingIndex(1);
	self.expIcon:setLocation(-80, 27, 0);
end

function Lua_WarCoinTaskItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.expIcon:setData(data.tvo);

	-- 任务类型 1 固定性，2 指引性
	if data.task_type == 1 then
		local desTab = {data.dec, "（{1}/{2}）"};
		self.expIcon:showNum(data.tvo.count, true);
		if data.limit_times - data.finish_times > 0 then
			self.desTxt.text = LanUtil.formateStr(table.concat(desTab, ""), data.cur_process, data.process);
		else
			self.desTxt.text = LanUtil.formateStr(table.concat(desTab, ""), data.process, data.process);
		end
		
		self.targetBg.mouseEnable = false;
		self.targetTxt.text = LanUtil.formateStr("奖励可领取次数：{1}", data.limit_times - data.finish_times);

		self.maskObj:SetActive(data.reward_state == 2);
		self:showRedDot(data.reward_state == 1);
	elseif data.task_type == 2 then
		self.expIcon:showNum(data.tvo.count, false);
		self.desTxt.text = data.dec;
		self.targetBg.mouseEnable = true;
		self.targetTxt.text = LanUtil.formateStr("前往活动");

		self.maskObj:SetActive(false);
		self:showRedDot(false);
	end
end

function Lua_WarCoinTaskItem:onPressClick(go)
	local winPos = LuaUtil.getTouchPosInverseObj(self.mainContent);
	if self.expIcon:checkInBound(winPos.x, winPos.y) then
		self:onShowItemClick();
	elseif self.data.task_type == 1 then
		if self.data.reward_state == 1 then
			Lua_MsgUtil.callFunc("DRAW_WARCOIN_REWARD", {eventType = 2, task_id = self.data.task_id});
		end
	elseif self.data.task_type == 2 then
		local xState = winPos.x >= (self.targetBg.posX - self.targetBg.width / 2) and  winPos.x <= (self.targetBg.posX + self.targetBg.width / 2);
		local yState = winPos.y >= (self.targetBg.posY - self.targetBg.height / 2) and  winPos.y <= (self.targetBg.posY + self.targetBg.height / 2);
		if xState and yState then
			self:onTargetActClick();
		end
	end
end

function Lua_WarCoinTaskItem:onShowItemClick()
	DataCenter.packUtil:showItemInfo(self.expIcon.data);
end

function Lua_WarCoinTaskItem:onTargetActClick(go)
	DataCenter.funcPathUtil:gotoFunction(self.data.fun_id, true)
end

function Lua_WarCoinTaskItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(142, 82, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_WarCoinTaskItem:dispose()
	if self.expIcon ~= nil then
		self.expIcon:dispose();
		self.expIcon = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end