Lua_WarCoinRewardWindow = class("Lua_WarCoinRewardWindow", Lua_Window);
function Lua_WarCoinRewardWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_WarCoinRewardWindow";
	self.skinName = "WarCoinRewardWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showClose = true;
end

function Lua_WarCoinRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.btnClose:setLocation(295, 330);

	self.standRewardList = Lua_DragList.new(self.content, 660, 112, Lua_AxisDefine.Horizontal);
	self.standRewardList:setListCell(Lua_ItemIconCell, 112, 112, 1);
	self.standRewardList:setCellSpacing(10, 0);
	self.standRewardList:setLocation(0, 95, 0);

	local newHeroActData = DataCenter.newHeroActData;
	self.standRewardList:setArrayData(newHeroActData.standRewardArr);
	if newHeroActData.standRewardArr:getSize() > 5 then
		self.standRewardList:setContentRect(640, 112)
	else
		self.standRewardList:setContentRect(newHeroActData.standRewardArr:getSize() * 122, 112);
	end

	self.totalRewardList = Lua_DragList.new(self.content, 660, 112, Lua_AxisDefine.Horizontal);
	self.totalRewardList:setListCell(Lua_ItemIconCell, 112, 112, 1);
	self.totalRewardList:setCellSpacing(10, 0);
	self.totalRewardList:setLocation(0, -155, 0);
	self.totalRewardList:setArrayData(newHeroActData.totalRewadArr);
	if newHeroActData.totalRewadArr:getSize() > 5 then
		self.totalRewardList:setContentRect(640, 112)
	else
		self.totalRewardList:setContentRect(newHeroActData.totalRewadArr:getSize() * 122, 112);
	end

	local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(newHeroActData.warCoinRechargeId);
	self.buyBtn.label = LanUtil.formateStr("{1}元解锁", tonumber(rechargeInfo.money));
	self.buyBtn:addClickFuntion(self, self.onBuyBtnClick);
end

function Lua_WarCoinRewardWindow:onBuyBtnClick(go)
	local rechargeId = DataCenter.newHeroActData.warCoinRechargeId;
	local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(rechargeId);
	DataCenter.sdkInterface:PointOut(1, tonumber(rechargeInfo.money), tonumber(rechargeInfo.money_type),
			tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
	self:hide();
end

function Lua_WarCoinRewardWindow:dispose()
	if self.standRewardList ~= nil then
		self.standRewardList:dispose();
		self.standRewardList = nil;
	end
	if self.totalRewardList ~= nil then
		self.totalRewardList:dispose();
		self.totalRewardList = nil;
	end

	self:superCall("dispose");
end