-- 升星专属（周期）(后台)
Lua_UpStarOfCyclePanel = class("Lua_UpStarOfCyclePanel", Lua_DisplayObject);
function Lua_UpStarOfCyclePanel:ctor(p, skinName)
	self:superCall("ctor", p, skinName);
end

function Lua_UpStarOfCyclePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardBg:SetDimensions(MainWinDefine.DEFAULT_WIDTH, 1280 + self.adaptHeight);

	self.freeTxt:setLangValue(203200);
	self.rechargeTxt:setLangValue(203201);

	self.giftList = Lua_DragList.new(self.content, 680, 822 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.giftList:setListCell(Lua_UpStarOfCycleRewardItem, 680, 130, 1);
	self.giftList:setLocation(0, -155, 0);

	self.introduceBtn:addClickFuntion(self, self.onTipsBtnClick);
	self.gotoRecruitBtn:addClickFuntion(self, self.onGotoRecruitClick);

	self:addLuaEvent("DRAW_UPSTAROF_CYCLE_REWARD", self, self.drawUpStarOfCycleReward);
    self:addLuaEvent("UPDATE_UPSTAROFCYCLE_INFO", self, self.updateUpStarOfCycleData);
end

function Lua_UpStarOfCyclePanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
	
	self.rewardBg:SetDimensions(MainWinDefine.DEFAULT_WIDTH, 1280 + adaptHeight);
	self.giftList:setContentRect(680, 822 + adaptHeight);
end

function Lua_UpStarOfCyclePanel:setData(data)
	self.data = data;
	self:startTimer();
end

function Lua_UpStarOfCyclePanel:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_UpStarOfCyclePanel", 1, self, self.updateLeftTime);
	end
end

function Lua_UpStarOfCyclePanel:updateLeftTime()
	if self.data.residueTime <= 0 then
		self.leftTimesTxt.text = "00时00分00秒";
		self:endTimer();
		return;
	end
	self.leftTimesTxt.text = Lua_TimeTransform.transSeconds18(self.data.residueTime, true, true, true, false);
end

function Lua_UpStarOfCyclePanel:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateLeftTime);
	end
end

function Lua_UpStarOfCyclePanel:onTipsBtnClick(go)
    local tipData = { des = self.data.help_des, posX = 200, posY = -110 };
    Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_UpStarOfCyclePanel:onGotoRecruitClick(go)
	if DataCenter.backstageActData:checkActIsEnd(self.data) then
		return;
	end
	DataCenter.funcPathUtil:gotoFunction(DataCenter.upStarOfCycleData.eventId, true)
end

function Lua_UpStarOfCyclePanel:drawUpStarOfCycleReward(giftId)
	if DataCenter.backstageActData:checkActIsEnd(self.data) then
		return;
	end
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sReceiveUpStarReward(self.data.actIdx, giftId);
end

function Lua_UpStarOfCyclePanel:updateUpStarOfCycleData()
	self.giftList:setArrayData(DataCenter.upStarOfCycleData.rewardInfo);
end

function Lua_UpStarOfCyclePanel:dispose()
	if self.giftList ~= nil then
		self.giftList:dispose();
		self.giftList = nil;
	end
	self:endTimer();

	self:superCall("dispose");
end





--------------------------------------------------





Lua_UpStarOfCycleRewardItem = class("Lua_UpStarOfCycleRewardItem", Lua_ListCell);
function Lua_UpStarOfCycleRewardItem:ctor(p)
	self:superCall("ctor", p, "UpStarOfCycleRewardItem_skin");
end

function Lua_UpStarOfCycleRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.heroIcon = Lua_ItemIcon.new(self.content);
	self.heroIcon:setLocation(-270, 0);
	self.heroIcon:setSiblingIndex(1);

	self.freeIcon = Lua_ItemIcon.new(self.content);
	self.freeIcon:setLocation(-140, 0);
	self.freeIcon:setSiblingIndex(2);

	self.rewardList = Lua_DragList.new(self.content, 240, 115, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_CycleRechargeRewardItem, 112, 112, 1);
	self.rewardList:setLocation(55, -2, 0);
	self:setSubList(self.rewardList);

	self.rechargeBtn:addClickFuntion(self, self.onRechargeClick);
end

function Lua_UpStarOfCycleRewardItem:setData(data)
	if data == nil then
		return;
	end
	self.data = data;

	local upStarOfCycleData = DataCenter.upStarOfCycleData;
	local curShowHero = Lua_ToolVo.createToolVo(upStarOfCycleData.heroId);
	curShowHero.star = data.star;
	self.heroIcon:setData(curShowHero);

	local freeRewardVo = Lua_ToolVo.createToolVo(data.free_cell.reward_item[1].id);
	self.freeIcon:setData(freeRewardVo);
	self.freeIcon:showText(4, data.free_cell.reward_item[1].amount);

	self.rechargeBtn.label = LanUtil.formateStr(203203, tonumber(data.recharge_cell.recharge));
	self.limitCountTxt.text = LanUtil.formateStr(203204, data.recharge_cell.curr_times, data.recharge_cell.limit_times)

	self.curHeroMaxStar = upStarOfCycleData.curHeroMaxStar;
	if self.curHeroMaxStar == nil then
		self.mask:setEnable(true);
		self.freeIcon:showEffect(false);
		self.rechargeBtn:setStyle(3);
	else
		self.mask:setEnable(data.star > self.curHeroMaxStar);
		self.freeIcon:showEffect(data.star <= self.curHeroMaxStar);
		self.rechargeBtn:setStyle(data.star > self.curHeroMaxStar and 3 or 1);
	end

	self.receiveIcon:setEnable(data.free_cell.curr_times <= 0);
	self.rechargeBtn:setEnable(data.recharge_cell.curr_times > 0);
	self.sellOutIcon:setEnable(data.recharge_cell.curr_times <= 0);
	self.limitCountTxt:setEnable(data.recharge_cell.curr_times > 0);
end

function Lua_UpStarOfCycleRewardItem:setCellSeqIndex(idx)
	self:superCall("setCellSeqIndex", idx);

	local rewardInfo = self.data.recharge_cell.reward_item;
	for i=1, #rewardInfo do
		rewardInfo[i].index = idx;
	end
	self.rewardList:setArrayData(rewardInfo);
	self.rewardList.canDrag = #rewardInfo >= 3;
end

function Lua_UpStarOfCycleRewardItem:onPressClick()
	local winPos = LuaUtil.getTouchPosInverseObj(self.mainContent);
	if self.freeIcon:checkInBound(winPos.x, winPos.y) then
		self:onBtnClick();
	end
end

function Lua_UpStarOfCycleRewardItem:onBtnClick()
	local upStarOfCycleData = DataCenter.upStarOfCycleData;
	if self.curHeroMaxStar ~= nil and self.curHeroMaxStar >= self.data.star and self.data.free_cell.curr_times > 0 then
		Lua_MsgUtil.callFunc("DRAW_UPSTAROF_CYCLE_REWARD", self.data.free_cell.gift_id);
	else
		DataCenter.packUtil:showItemInfo(self.freeIcon.data);
	end
end

function Lua_UpStarOfCycleRewardItem:onRechargeClick(go)
	if self.curHeroMaxStar ~= nil and self.curHeroMaxStar >= self.data.star and self.data.recharge_cell.curr_times > 0 then
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(self.data.recharge_cell.gift_id);
		DataCenter.sdkInterface:PointOut(1, tonumber(rechargeInfo.money), tonumber(rechargeInfo.money_type),
				tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
	else
		OperateAlert.show(LanUtil.formateStr(203205, self.heroIcon.data.name, self.data.star));
	end
end

function Lua_UpStarOfCycleRewardItem:dispose()
	if self.heroIcon ~= nil then
		self.heroIcon:dispose();
		self.heroIcon = nil;
	end
	if self.freeIcon ~= nil then
		self.freeIcon:dispose();
		self.freeIcon = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_CycleRechargeRewardItem = class("Lua_CycleRechargeRewardItem", Lua_ListCell);
function Lua_CycleRechargeRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_CycleRechargeRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rechargeIcon = Lua_ItemIcon.new(self.content);
	self.rechargeIcon:setLocation(0, 0);
	self.rechargeIcon:setSiblingIndex(0);

	self.receiveIcon = UICreate.createUIAtlasImage(self.content, "excellentActivity_atlas", "receiveIcon", -1, 1, 0, 0);
end

function Lua_CycleRechargeRewardItem:setData(data)
	if data == nil then
		return;
	end
	self.data = data;

	local rechargeRewardVo;
	rechargeRewardVo = Lua_ToolVo.createToolVo(data.id);
	self.rechargeIcon:setData(rechargeRewardVo);
	self.rechargeIcon:showText(4, data.amount);

	local buyTimes = DataCenter.upStarOfCycleData.rechargeInfo[data.index];
	self.receiveIcon:setEnable(buyTimes.limitRechargeTimes <= 0);
end

function Lua_CycleRechargeRewardItem:onPressClick(go)
	DataCenter.packUtil:showItemInfo(self.rechargeIcon.data);
end

function Lua_CycleRechargeRewardItem:dispose()
	if self.rechargeIcon ~= nil then
		self.rechargeIcon:dispose();
		self.rechargeIcon = nil;
	end
	if self.receiveIcon ~= nil then
		self.receiveIcon:dispose();
		self.receiveIcon = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end